package demos;
import java.net.Socket;

import java.io.OutputStream;
import java.io.InputStream;


// #################################################
// ##                                             ##
// ## THIS PROGRAM SIMULATES TELNET (WITHOUT THE  ##
// ## CONTROL KEYS)                               ##
// ##                                             ##
// ## (c) Hernadvolgyi, 2002                      ##
// ##                                             ##
// #################################################
public class Telnet {

   private class Reader extends Thread {

      public void run() {
         try {
            InputStream is = conn.getInputStream();
            for(;;) {
               int c = is.read();
               if (c == -1)  break;
               System.out.write(c);
               System.out.flush();
            }
         } catch (Exception e) {
            System.out.println(">> " + e.getMessage());
         }
      }
   }

   private class Writer extends Thread {

      public void run() {
         try {
            OutputStream os = conn.getOutputStream();
            for(;;) {
               int c = System.in.read();
               if (c == -1)  break;
             
               os.write(c);
               os.flush();
            }
         } catch (Exception e) {
            System.out.println(">> " + e.getMessage());
         }
      }
   }

   private Socket conn;
   public Telnet(String host, int port) throws Exception {
      conn = new Socket(host,port);
      (new Reader()).start();
      (new Writer()).start();
   }

   // make a new connection to the server and run telnet
   // (without the control keys, so it will not work on port 23 
   //  with a traditional Telnet server)
   public static void main(String [] argv) throws Exception {
      if (argv.length != 2) {
         System.out.println("java demos.Telnet <host> <port>");
         return;
      }
      new Telnet(argv[0],Integer.parseInt(argv[1]));
   }
}
